
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>关于MySQL-Proxy子进程异常退出BUG修复 / 憋错料</title>

    <meta name="description" content="关于MySQL-Proxy子进程异常退出BUG修复 关于 MySQL-Proxy 子进程异常退出的问题,我已经在之前的博文中提到过: http://sofar.blog.51cto.com/353572/1398820 相关的错误信息如下图所示: 经查阅11号信号为SIGSEGV,表示进程执行了一个无效的内存引用或发生段错误,从而导致子进程异常退出. 我们知道 MySQL-Proxy 采用的是父子进程的模式,处理请求都是由子进程来完成的,而父进程只起到监控子进程的作用, 我们一般会在 MySQL-Proxy 的配置文件中添加&quot;keepa ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">关于MySQL-Proxy子进程异常退出BUG修复</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>关于 MySQL-Proxy 子进程异常退出的问题，我已经在之前的博文中提到过：</p>
<p><a href="http://sofar.blog.51cto.com/353572/1398820" rel="external nofollow noreferrer">http://sofar.blog.51cto.com/353572/1398820</a></p>
<p>相关的错误信息如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvMjcvQTAvd0tpb20xTnpndldqRmFubkFBRDVCOXl0bDhVNjU0LmpwZw==.jpg" /></p>
<p>经查阅11号信号为SIGSEGV，表示进程执行了一个无效的内存引用或发生段错误，从而导致子进程异常退出。</p>
<p>我们知道 MySQL-Proxy 采用的是父子进程的模式，处理请求都是由子进程来完成的，而父进程只起到监控子进程的作用， 我们一般会在 MySQL-Proxy 的配置文件中添加“keepalive=true”参数，以确保在子进程异常退出时，由父进程自动将其拉起。</p>
<p>刚开始定位到以下两个源码文件：</p>
<p>src/chassis-unix-daemon.c</p>
<p>src/chassis-mainloop.c</p>
<p>在其中看到了对 SIGTERM/SIGINT/SIGHUP 三个信号的处理，于是也按照类似的方法添加了对 SIGSEGV 信号的处理（将其信号忽略掉），修改大致如下：</p>
<p><strong>src/chassis-unix-daemon.c:</strong></p>
<pre>signal(SIGSEGV, chassis_unix_signal_forward);
......
signal(SIGSEGV, SIG_DFL);</pre>
<p><strong>src/chassis-mainloop.c:</strong></p>
<pre>struct event ev_sigterm, ev_sigint, ev_sigsegv;
......
signal_set(&amp;ev_sigsegv, SIGSEGV, sigsegv_handler, NULL);
event_base_set(chas-&gt;event_base, &amp;ev_sigsegv);
signal_add(&amp;ev_sigsegv, NULL);
......
signal_del(&amp;ev_sigsegv);</pre>
<p>虽然不再报错，也能正常工作，但好景不长，5分钟左右就挂掉了。因为我们将 SIGSEGV 信号忽略掉了，子进程异常退出时，父进程收不到导致子进程异常退出的 SIGSEGV 信号，当然也就无法正常将其子进程拉起，所以此方法不能解决我们的问题。</p>
<p>既然以上方法不能解决我们的问题，于是就想到了通过开启 coredump 的方式来进行调试追踪，设置如下：</p>
<p># ulimit -c unlimited</p>
<p># echo "1" &gt; /proc/sys/kernel/core_uses_pid</p>
<p># mkdir -p /root/corefile</p>
<p># echo "/root/corefile/core-%e-%p-%t" &gt; /proc/sys/kernel/core_pattern</p>
<p>重新编译 MySQL-Proxy（注意要加上“-g”参数）：</p>
<p># ./configure --prefix=/usr/local/mysql-proxy \</p>
<p>--with-lua=/usr/local/lua \</p>
<p>--with-mysql=/usr/local/mysql \</p>
<p>GLIB_CFLAGS="-I/usr/local/glib-2.32.4/include/glib-2.0" \</p>
<p>GLIB_LIBS="-L/usr/local/glib-2.32.4/lib/glib-2.0 -lglib-2.0" \</p>
<p>GMODULE_CFLAGS="-I/usr/local/glib-2.32.4/include" \</p>
<p>GMODULE_LIBS="-L/usr/local/glib-2.32.4/lib -lgmodule-2.0" \</p>
<p>GTHREAD_CFLAGS="-I/usr/local/glib-2.32.4/include" \</p>
<p>GTHREAD_LIBS="-L/usr/local/glib-2.32.4/lib -lgthread-2.0" \</p>
<p>LDFLAGS="-L/usr/local/lib -lm -L/usr/local/lib64 -lcrypto" \</p>
<p>LUA_CFLAGS="-I/usr/local/lua/include" \</p>
<p>LUA_LIBS="-L/usr/local/lua/lib -llua-5.1 -ldl" \</p>
<p>CFLAGS="-DHAVE_LUA_H -g"</p>
<p># make &amp;&amp; make install</p>
<p>再次启动编译后的 MySQL-Proxy 程序，几分钟后会生成如下core文件：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvMjcvQTEvd0tpb0wxTnppMm1SalVGaEFBREduNGxHblNZOTg5LmpwZw==.jpg" /></p>
<p>采用 GDB 进行追踪调试：</p>
<p># cd /usr/local/mysql-proxy/bin</p>
<p># gdb ./mysql-proxy /root/corefile/core-mysql-proxy-32354-1400039241</p>
<p>得到如下信息：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvMjcvQTAvd0tpb20xTnpqSjNpMF8wTkFBWl9BQzJXLTNjODc1LmpwZw==.jpg" /></p>
<p>通过参考360的Atlas源码，我们最终定位到network-conn-pool-lua.c中的network_connection_pool_lua_add_connection函数，修改如下：</p>
<p>修改前：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvMjcvQTEvd0tpb0wxTnpqaDZ4a3BPVkFBSUdmdDVyajFNNDc2LmpwZw==.jpg" /></p>
<p>修改后：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvMjcvQTEvd0tpb0wxTnpqbnJpdXlPSEFBTzJhN0NUNDVvNjcyLmpwZw==.jpg" /></p>
<p>我们可以在 360 Atlas 的对应修改位置，看到如下信息，我想大家应该明白是什么原因引起了吧！！！</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvMjcvQTIvd0tpb20xTnpsRlNCMGUwY0FBRHhvbXpZaC0wNTIwLmpwZw==.jpg" /></p>
<p>经测试，一切 OK ！！！<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJhaWR1LmNvbS9oaS9qeDIval8wMDY3LmdpZg==.jpg" /></p>

<p><P>关于MySQL-Proxy子进程异常退出BUG修复</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 15:54:24 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/mysql-proxy/" title="mysql-proxy">mysql-proxy</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>关于MySQL-Proxy子进程异常退出BUG修复的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz1LXq4.html" rel="bookmark">阿里云ECS（linux）磁盘满触发的mysql的表异常修复案例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阿里云ECS(linux)磁盘满触发的mysql的表异常修复案例 阿里云技术支持:完颜镇江 问题现象: 磁盘空间满了,第一想到的就是删除无用的服务日志或者升级数据盘. 通常是使用du –sh去分析目录找出占用最大的. 根据经验来说基本都是日志文件占用的,那么就是停止应用清理日志,或者清理日志后重启应用即可. 但是本实例的异常是网站主页正常,但是子导航的内容为空,首先怀疑的就是磁盘满了导致mysql数据库的数据异常. 问题排查: 排查的方法是打开mysql的errlog 添加以下配置重启mysql			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lA9QP3.html" rel="bookmark">C&num;关于软件界面无响应、BUG报警、程序异常退出等情况的监控和报警</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对程序的监控,一般采用另外一个进程进行监控(即主进程和监控进程),主进程运行后,先查找下看有没有还在残留运行的监控进程,如果有先结束监控进程,然后重新启动. 如何监控主程序的思路是:主程序中开辟一个共享内存映射文件,通过定时器向文件写入变化的信号数据(自定义).监控程序定时从共享内存文件中读取信号数据,并和上次读取的信号数据进行对比,如果不一致表示主程序运行正常,如果不一致,表示运行异常或者程序异常退出. 内存映射文件 内存映射文件是由一个文件到进程地址空间的映射. C#提供了允许应用程序把文件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n4AkKg0.html" rel="bookmark">MySQL Proxy实现数据的读写分离</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				做MySQL读写分离实验之前,先要搭建MySQL主从复制,可以参考我之前的两篇文章: MySQL主从配置:http://msiyuetian.blog.51cto.com/8637744/1697288 部署搭建分层次LAMP架构(最后一章节):http://msiyuetian.blog.51cto.com/8637744/1740236 实现了主从复制后,下面我们进行读写分离的安装与配置.环境说明: Linux发行版本:centos 6.7 x86_64 (三台) Hostname IP 备			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ORDVr0.html" rel="bookmark">erlang监控进程在启动进程退出后异常退出原因分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.问题引出 erlang监控进程在启动时设置了trap_exit为true,即会捕获到退出信号,会将退出信号转换为{'EXIT',Pid,Reason}存入自己的邮箱中,因此与监控进程link关系的进程退出后,监控进程能够很坦然的截获退出信号,自身不退出.启动erlang监控进程的进程,会和监控进程建立link关系,然而当启动进程退出时,监控进程没有象正常的情况,发生了异常退出,为什么设置了trap_exit为true,还会退出呢? 二.原因分析 查看supervisor的源码,supervi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz1Nel4.html" rel="bookmark">MySQL Proxy 实现 MySQL 读写分离提高并发负载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				工作拓扑: MySQL Proxy有一项强大功能是实现&quot;读写分离&quot;,基本原理是让主数据库处理写方面事务,让从库处理SELECT查询. Amoeba for MySQL是一款优秀的中间件软件,同样可以实现读写分离,负载均衡等功能,并且稳定性也高于MySQL Proxy,有兴趣的可以测试一下. 环境描述: 操作系统:CentOS6.3_x64 主服务器Master:192.168.0.202 从服务器Slave:192.168.0.203 调度服务器MySQL-Proxy:192.168.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AZWqKM.html" rel="bookmark">MHA监控进程异常退出（MHA版本：0&period;56）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近遇到一个非常诡异的问题,mha后台进程自己中断退出了.以下是报错:Mon Dec 21 20:16:07 2015 - [info] OK.Mon Dec 21 20:16:07 2015 - [warning] shutdown_script is not defined.Mon Dec 21 20:16:07 2015 - [info] Set master ping interval 1 seconds.Mon Dec 21 20:16:07 2015 - [info] Set sec			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZbX1J3.html" rel="bookmark">MySQL Proxy使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用MySQL将读写请求转接到主从Server. 一 安装MySQL Proxy MySQL Proxy的二进制版非常方便,下载解压缩后即用. 解压缩的目录为: $mysql-proxy_installed_dir (这里为/usr/local/mysql-proxy) |_ bin |_ include |_ lib |_ share 1. 为mysql-proxy建立配置文件. 如在$mysql-proxy_installed_dir创建文件mysql-proxy.cnf,内容如下: Tex			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0b57qkM.html" rel="bookmark">使用MySQL Proxy解决MySQL主从同步延迟</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL的主从同步机制非常方便的解决了高并发读的应用需求,给Web方面开发带来了极大的便利.但这种方式有个比较大的缺陷在于MySQL的同步机制 是依赖Slave主动向Master发请求来获取数据的,而且由于服务器负载.网络拥堵等方面的原因,Master与Slave 之间的数据同步延迟是完全没有保证的.短在1秒内,长则几秒.几十秒甚至更长都有可能. 由于数据延迟问题的存在,当应用程序在Master 上进行数据更新,然后又立刻需要从数据库中读取数据时,这时候如果应用程序从Slave上取数据(这也是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDnWWk3.html" rel="bookmark">解决Banshee 启动后异常退出的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Ubuntu上,启动Banshee后,有时会发生Banshee立刻退出的情况.通过从命令行启动banshee,发现报出如下异常. Unhandled Exception: GLib.GException: No such file or directory at GLib.FileAdapter.EnumerateChildren (System.String attributes, FileQueryInfoFlags flags, GLib.Cancellable cancellable)			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQbKy3.html" rel="bookmark" class="title">python画完图后运行闪退解决办法</a>
					<div>
						最近学习python,用matplotlib库画图,运行程序后,就会闪退. 解决办法:     python2.*后面加上:raw_input()     python3.*后面加上:input()  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bnydY0.html" rel="bookmark" class="title">Python之路-文件操作（py）</a>
					<div>
						文件操作的基本步骤: 1.打开文件:f=open('filename'),with open('filename') as f 2.操作文件:增,删,改,查 3.关闭文件:f.close 打开文件 p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mml2RV4.html" rel="bookmark" class="title">AIDL</a>
					<div>
						AIDL的作用 在Android平台,每个应用程序都是一个单独的JVM,都运行在自己的进程空间里, 通常,一个进程不允许访问另一个进程的内存空间(一个应用不能访问另一个应用).当用户(程序开发人员)想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLD5OdM.html" rel="bookmark" class="title">Linux内核中网络数据包的接收-第一部分 概念和框架</a>
					<div>
						与网络数据包的发送不同,网络收包是异步的的,因为你不确定谁会在什么时候突然发一个网络包给你,因此这个网络收包逻辑其实包含两件事:1.数据包到来后的通知2.收到通知并从数据包中获取数据这两件事发生在协议 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dA5K93.html" rel="bookmark" class="title">正则的小效果：-------&amp;gt&semi;  过滤敏感词</a>
					<div>
						&lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;UTF-8&quot;&gt; &lt;title&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J8bgb0.html" rel="bookmark" class="title">Swift &quest;和&excl;</a>
					<div>
						比如: let window=UIApplication.sharedApplication().delegate?.window window!!.rootViewController=TabBar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rkzr94.html" rel="bookmark" class="title">手写PE文件（二）</a>
					<div>
						[文章标题]: 纯手工编写的PE可执行程序 [文章作者]: Kinney [作者邮箱]: [email protected] [下载地址]: 自己搜索下载 [使用工具]: C32 [操作平台]: wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1XVJ4.html" rel="bookmark" class="title">使用 Acegi 保护 Java 应用程序</a>
					<div>
						第 1 部分: 架构概览和安全过滤器 Acegi Security System 是一种功能强大并易于使用的替代性方案,使您不必再为 Java 企业应用程序编写大量的安全代码.虽然它专门针对使用 Sp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02kYzp3.html" rel="bookmark" class="title">查看oracle 数据库的DBID</a>
					<div>
						(1)使用rman查看$ rman target /Recovery Manager: Release 11.2.0.4.0 - Production on Fri Jun 12 03:20:19 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lk9xXM.html" rel="bookmark" class="title">HCIE实验LAB&lowbar;1（7）</a>
					<div>
						Section 7 : Network management 7.2 Netstream ip netstream aggregation destination-prefix enable vers ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDyDDw0.html" rel="bookmark" class="title">C语言  &amp;&num;183&semi;  明明的随机数</a>
					<div>
						算法训练 明明的随机数 时间限制:1.0s   内存限制:256.0MB 问题描述 明明想在学校中请一些同学一起做一项问卷调查,为了实验的客观性,他先用计算机生成了N个1到1000之间的随机整数(N≤ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPdlP4.html" rel="bookmark" class="title">poj 3628 Bookshelf 2 基本01背包</a>
					<div>
						题目大意:FJ有n头奶牛,和一个高为h的架子,给出每头奶牛高度,求使奶牛叠加起来超过架子的最低高度是多少. 题目思路:求出奶牛叠加能达到的所有高度,并用dp[]保存,最后进行遍历,找出与h差最小的dp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoL5eb0.html" rel="bookmark" class="title">CSON vs JSON</a>
					<div>
						今天在github浏览资料时,无意发现了这个很像json,却优于json的cson.故,再次分享给大家! 官方fork文档:https://github.com/xgqfrms/cson What i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35rKyv4.html" rel="bookmark" class="title">暖房子工程</a>
					<div>
						暖房子工程终于快结束了,墙面新刷涂料后整个楼变成新楼啦! 今年冬天屋里会暖和点--!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xa9Oj3.html" rel="bookmark" class="title">【学习笔记】信息系统项目管理-配置管理-配置库分类</a>
					<div>
						配置库也称为配置项库.用来存放配置项的工具.主要分为下面三类. 1.开发库 development library 存放开发过程中须要保留的信息.供开发者专用. 库中信息可能较为频繁的改动.这通常不会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0azmYE3.html" rel="bookmark" class="title">主机如何访问运行在虚拟机中的Django项目</a>
					<div>
						最近在学习python web 开发,使用的Django框架.在虚拟机中配置好了Django开发环境,想试一下看Django内置的Demo能否运行 通过python manage.py runserv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWjrqa4.html" rel="bookmark" class="title">20140505朗沃</a>
					<div>
						今天我们学习了类.对象和包,首次接触到了面对对象编程的思想,这和以往的面向过程编程的思维模式有很大不同,以至于我的思路一时还不能完全转变,但从老师列举出的例子中能够看出,面向对象编程相对于面向过程编程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47Xk5xM.html" rel="bookmark" class="title">linux服务安装基本常用步骤</a>
					<div>
						linux服务安装基本常用步骤 Linux上,安装服务的基本步骤如下: 首先配置源: 挂载CD盘 mount /dev/cdrom /mnt 软件目录: /mnt/Packages/xxx   for ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k61GEM.html" rel="bookmark" class="title">lnmp安装--php安装</a>
					<div>
						版本:php5.6.4 x86_64 centos 6.6 x86_64 安装php之所以难,是因为要安装的扩展多,依赖关系复杂. 安装前的准备: 先看你想要安装哪些扩展.需要哪些包.下载地址:htt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mynvxj0.html" rel="bookmark" class="title">《Python高效开发实战》实战演练&mdash;&mdash;建立应用2</a>
					<div>
						为了在项目中开发符合MVC架构的实际应用程序,需要在项目中建立Django应用.每个Django项目可以包含多个Django应用.建立应用的语法为: #python manage.pystartapp ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
